from typing import Optional

from bot_data.abc.history_table_abc import HistoryTableABC


# had to name it UserWarnings instead of UserWarning because UserWarning is a builtin class
class UserWarningsHistory(HistoryTableABC):
    def __init__(
        self,
        description: str,
        user: int,
        author: Optional[int],
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._description = description
        self._user = user
        self._author = author

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def description(self) -> str:
        return self._description

    @property
    def user(self) -> int:
        return self._user

    @property
    def author(self) -> Optional[int]:
        return self._author
