import { Component, EventEmitter, Input, Output } from "@angular/core";
import { Column } from "../../../../base/component-with-table";

@Component({
  selector: "app-multi-select-columns",
  templateUrl: "./multi-select-columns.component.html",
  styleUrls: ["./multi-select-columns.component.scss"]
})
export class MultiSelectColumnsComponent {
  @Input() columns: Column[] = [];

  private _hiddenColumns: Column[] = [];
  @Input() table: String = "";

  @Input()
  set hiddenColumns(columns: Column[]) {
    this._hiddenColumns = columns;
    this.hiddenColumnsChange.emit(columns);
  }

  get hiddenColumns(): Column[] {
    return this._hiddenColumns;
  }

  get visibleHiddenColumns(): Column[] {
    return this._hiddenColumns.filter(x => x.key?.startsWith(`${this.table}_`));
  }

  @Output() hiddenColumnsChange: EventEmitter<Column[]> = new EventEmitter<Column[]>();
}
